#pragma once

#include "ehs/Types.h"

namespace ehs
{
	enum class DbType : UInt_8
	{
		SINT_64,
		UINT_64,
		SINT_32,
		UINT_32,
		SINT_16,
		UINT_16,
		SINT_8,
		UINT_8,
		FLOAT,
		DOUBLE,
		BOOLEAN,
		CHAR_32,
		CHAR_16,
		CHAR_8
	};

	constexpr UInt_8 DbTypeToSize(const DbType type)
	{
		switch (type)
		{
			case DbType::SINT_64:
				return 8;
			case DbType::UINT_64:
				return 8;
			case DbType::SINT_32:
				return 4;
			case DbType::UINT_32:
				return 4;
			case DbType::SINT_16:
				return 2;
			case DbType::UINT_16:
				return 2;
			case DbType::SINT_8:
				return 1;
			case DbType::UINT_8:
				return 1;
			case DbType::FLOAT:
				return 4;
			case DbType::DOUBLE:
				return 8;
			case DbType::BOOLEAN:
				return 1;
			case DbType::CHAR_32:
				return 4;
			case DbType::CHAR_16:
				return 2;
			case DbType::CHAR_8:
				return 1;
			default:
				return 0;
		}
	}
}
